#include "stdio.h"
#include "stdlib.h"
#include "mem.h"
#include "string.h"

typedef struct _ride
{
unsigned int driver;
double x1, y1, x2, y2;
}
_ride;

unsigned int cntRides = 0;
struct _ride ride[10000];

void LoadDrivers( char * fname )
{
FILE *f;
unsigned int i;
char s[128];

f=fopen( fname, "rt" );
if(!f)
	{
	printf( "Can't open %s\n", fname );
	exit(1);
	}

i=0;
while(fgets(s,sizeof(s),f))
	{
	if( strstr( s, "driver" ))
		continue;

	sscanf( s, "%d\t%lf,%lf\t%lf,%lf", &ride[i].driver, &ride[i].x1, &ride[i].y1, &ride[i].x2, &ride[i].y2 );
	i++;

	if( i >= (sizeof(ride)/sizeof(ride[0])) )
		{
		printf( "Too much data in %s\n", fname );
		exit(1);
		}
	}
cntRides=i;
};


char pic[1800][4300];

void ClearPic( void )
{
memset( pic, '0', sizeof(pic));
}

void SetPoint( double x, double y )
{
int line, col;
int i, j;
line = 1800 - ( (int)( x * 100.0 ) - 3000);
col = 4300 - ((int)(y * -100.0) - 8000);
for( i=-2; i < 3; i++ ) for( j=-2; j < 3; j++ ) pic[line+i][col+j] = '1';
}

void SavePic( char * fname )
{
FILE *f;
int line, col;

f=fopen( fname, "wt" );
if(!f)
	{
	fprintf( stderr, "Can't write %s\n", fname );
	return;
	}
fprintf( stderr, "Saving %s\n", fname );
fprintf( f, "P1\n#\n4300 1800\n" );
fwrite( &pic[0][0], 4300, 1800, f );
fclose(f);
}

int X( double x )
{
return 40 - ((int)(x*100.0) - 3700);
}

int Y( double y )
{
return (12230+(int)(y*100.0));
}

void GenSvg88( char * fname )
{
FILE *f;
unsigned int i;

f=fopen( fname, "wt" );
if(!f)
	{
	printf( "Can't create %s\n", fname );
	return;
	}

fprintf( f, "\x3C" "?xml version=\"1.0\"?" "\x3E" );
fprintf( f, "\x3C" "svg width=\"840\" height=\"30\" viewBox=\"0 0 840 30\" xmlns=\"http://www.w3.org/2000/svg\"" "\x3E" "\n" );

for( i=0; i < cntRides; i++ )
	{
	if( 88 == ride[i].driver )
		{
fprintf( f, "\x3c" "line x1=\"%d\" y1=\"%d\" x2=\"%d\" y2=\"%d\" stroke=\"black\" stroke-width=\"2\"/" "\x3e" "\n", 
Y(ride[i].y1), X(ride[i].x1), Y(ride[i].y2), X(ride[i].x2) );
		}
	};

fprintf( f, "\x3c" "/svg" "\x3e" );
fclose(f);
}

void main()
{
unsigned int i, j, drv;

LoadDrivers( "mail0009-attachment.bin" );

// create picture with all starting and ending points

ClearPic();

for( i=0; i < cntRides; i++ )
	{
	SetPoint( ride[i].x1, ride[i].y1 );
	SetPoint( ride[i].x2, ride[i].y2 );
	};

SavePic( "drv-all.pbm" );

// now create per-driver pictures
for( drv=1; drv <= 123; drv++ )
	{
	char s[16];
	ClearPic();

	for( i=0; i < cntRides; i++ )
		{
		if( ride[i].driver == drv )
			{
			SetPoint( ride[i].x1, ride[i].y1 );
			SetPoint( ride[i].x2, ride[i].y2 );
			}
		};

	sprintf( s, "drv%.3d.pbm", drv );
	SavePic(s);
	};

// now generate the flag picture
GenSvg88( "flag.svg" );
}

