#include "stdio.h"
#include "string.h"
#include "stdlib.h"

typedef struct _mousedata
{
  int btn, dx, dy, x, y;
} _mousedata;

int cntMouse = 0;
struct _mousedata mdata[10000];
char s[1024];

unsigned char prevKeys[8] = { 0, 0, 0, 0, 0, 0, 0, 0 };

void
HexStrToBytes (char *hex, char *outbuf)
{
  char *q;
  while (hex && hex[0] && hex[1])
    {
      char x[3];
      x[0] = hex[0];
      x[1] = hex[1];
      x[2] = 0;
      outbuf[0] = strtoul (x, &q, 16);
      hex += 2;
      outbuf++;
    }
}

void
Keyboard (char *z)
{
  char x[16];
  unsigned char c;
  char *q;
  int i;
  unsigned long int v;
  unsigned char b[8];

  HexStrToBytes (z, &b[0]);

  c = b[2];
  if (b[3])
    c = b[3];

  if (prevKeys[3] == c)
    c = 0;

  if (c)
    {
      if (8 == b[0])
	printf ("{Win}+");
      if (4 == b[0])
	printf ("{Alt}+");

      switch (c)
	{
	case 0x38:
	  printf ("-");
	  break;
	case 0x32:
	  printf ("'");
	  break;
	case 0x37:
	  printf ((b[0] == 2) ? ":" : ".");
	  break;
	case 0x28:
	  printf ("{Enter} ");
	  break;
	case 0x2B:
	  printf ("{Tab} ");
	  break;
	case 0x2A:
	  printf ("{Backspace} ");
	  break;
	case 0x2C:
	  printf (" ");
	  break;
	case 0x36:
	  printf (",");
	  break;

	default:
	  if (c >= 4 && c <= 29)
	    printf ("%c", c + ((2 == b[0]) ? 'A' : 'a') - 4);
	  else
	    printf ("{%.2X}", c);
	  break;
	};
    };

  memcpy (prevKeys, b, 8);
}

void
Mouse (char *z)
{
  signed char b[4];

  HexStrToBytes (z, &b[0]);

  mdata[cntMouse].btn = b[0];
  mdata[cntMouse].dx = b[1];
  mdata[cntMouse].dy = b[2];
  cntMouse++;
  if (cntMouse >= (sizeof (mdata) / sizeof (mdata[0])))
    {
      exit (1);
    }

}

#define PICWIDTH 1800
#define PICHEIGHT 500

char pic[PICHEIGHT][PICWIDTH];

void
ClearPic (void)
{
  memset (pic, '0', sizeof (pic));
};

void
SetPoint (int x, int y)
{
  pic[y][x] = '1';
};

void
DrawSquare (int x, int y)
{
  int a, b;
  for (a = -3; a <= +3; a++)
    for (b = -3; b <= +3; b++)
      SetPoint (x + a, y + b);

}

void
SavePic (char *fname)
{
  FILE *f;

  f = fopen (fname, "wt");
  if (!f)
    return;

  fprintf (f, "P1\n#\n%d %d\n", PICWIDTH, PICHEIGHT);
  fwrite (&pic[0][0], PICWIDTH, PICHEIGHT, f);
  fclose (f);
}

void
SavePic2 (int i)
{
  char fname[16];
  sprintf (fname, "mouse%.3d.pbm", i);
  SavePic (fname);
}


void
DrawAllVirtualKeys (void)
{
  int i;
  for (i = 544; i <= 4770; i++)
    {
      if (mdata[i].btn)
	DrawSquare (mdata[i].x, mdata[i].y);
    }
}


void
main (void)
{
  FILE *f;
  int i, j, x, y;
  int k;
  char *p, *q;

  static const char *inputFile = "exported.txt";

  f = fopen (inputFile, "rt");
  if (!f)
    {
      printf ("Can't open %s\n", inputFile);
      exit (1);
    }

  while (fgets (s, sizeof (s), f))
    {
      k = strlen (s);
      if (k)
	if (10 == s[k - 1])
	  s[--k] = 0;
      if (!k || !strstr (s, "Leftover"))
	continue;
      p = strstr (s, ": ");
      if (!p)
	continue;
      p += 2;
      k = strlen (p);

      if (k >= 16)
	Keyboard (p);
      else
	Mouse (p);
    }

// draw all mouse movements and clicks in one picture

  x = 1200;
  y = 300;
  ClearPic ();
  for (i = 0; i < cntMouse; i++)
    {
      x += mdata[i].dx;
      y += mdata[i].dy;
      mdata[i].x = x;
      mdata[i].y = y;
      SetPoint (x, y);
      if (mdata[i].btn)
	DrawSquare (x, y);
    }
  SavePic ("mouse-all.pbm");

// draw each mouse movement in separate picture, but with all virtual keypresses
  ClearPic ();
  for (i = 544, j = 0; i <= 4770; i++)
    {
      SetPoint (mdata[i].x, mdata[i].y);

      if (mdata[i].btn)
	{
	  DrawAllVirtualKeys ();
	  SavePic2 (j);
	  j++;
	  ClearPic ();
	};
    };
}
